
#include "Frame.h"
#include "BasicFrame.h"
#include "wx.h"


void Frame::CreateIfNeeded() {
 if (!frame) {
      frame = new BasicFrame( name, xCoord, yCoord, width, height, this );
      frame->Show(TRUE); 
//    frame->SetSize( xCoord, yCoord, width+1, height);
   }
}

Frame::Frame(char *nm, int x, int y, int w, int h) {
     name   = copystring(nm); 
     xCoord = x; 
     yCoord = y; 
     width  = w; 
     height = h;
     frame  = (BasicFrame*)0; 
}

Frame::Frame(char *nm, int x, int y) {
     name   = copystring(nm); 
     xCoord = x; 
     yCoord = y; 
     width  = 100; 
     height = 100;
     frame  = (BasicFrame*)0; 
}
  
  
Frame::Frame(char *nm) {
     name   = copystring(nm); 
     xCoord = 1; 
     yCoord = 1; 
     width  = 100; 
     height = 100;
     frame  = (BasicFrame*)0; 
}

Frame::Frame() {
     name = "NoName";
     xCoord = 1; 
     yCoord = 1; 
     width  = 100; 
     height = 100;
     frame  = (BasicFrame*)0; 
} 
        
Frame::~Frame() {
}

void Frame::MoveTo( int newX, int newY ) {
       CreateIfNeeded();
       xCoord = newX; yCoord = newY;
       frame->SetSize( xCoord, yCoord, width, height);
}

void Frame::Resize( int newW, int newH ) {
       CreateIfNeeded();        
       width = newW; height = newH;
       frame->SetSize( xCoord, yCoord, width, height);
}

void Frame::Resize(float factor) {
       CreateIfNeeded();
       width = width*factor;
       height = height*factor;
       frame->SetSize( xCoord, yCoord, width, height);
}

void Frame::DrawText(char *msg, int x, int y) 
{
    CreateIfNeeded();
    frame->canvas->DrawText(msg, x, y);
}


void Frame::TextSize(char *msg, int& w, int& h) 
{
    float wf, hf, descent, leading;
    CreateIfNeeded();
    wxCanvasDC* dc = frame->canvas->GetDC();
    dc->GetTextExtent(msg, &wf, &hf, &descent, &leading);
    w = (int)wf;
    hf = hf + 1;
    h = (int)hf;
}



void Frame::Clear() 
{
    CreateIfNeeded();
    frame->canvas->Clear();
}

void Frame::Clear(int x, int y, int w, int h) 
{
    CreateIfNeeded();
    frame->canvas->SetClippingRegion((float)x, (float)y, (float)w, (float)h);
    frame->canvas->Clear();
    frame->canvas->DestroyClippingRegion();
}

void Frame:: DrawLine(int x1, int y1, int x2, int y2) 
{
    CreateIfNeeded();
    frame->canvas->DrawLine((float)x1,(float)y1,(float)x2,(float)y2);
}

void Frame::DrawCircle(int x, int y, int r)
{
    CreateIfNeeded();
    frame->canvas->DrawEllipse((float)(x-r), (float)(y-r), 
                               (float)(2*r), (float)(2*r));

}

int Frame::IsNamed(char *nm) {
   if (strcmp(name, nm) == 0) return 1;
   return 0;
 }





