#include "StartFrame.h"
#include "wx.h"
#include "Base.h"

void button_proc(wxButton& button, wxCommandEvent& );

void MyTimer::Notify(void)
{
  OnTimerEvent();
};

StartFrame::StartFrame() : wxFrame(NULL, "Start Window", 1, 1, 300, 100) 
{
  wxPanel* panel = new wxPanel(this, -1, -1, -1, -1);
  new wxButton(panel, (wxFunction)&button_proc , "Start");
  slider = new wxSlider(panel, (wxFunction)StartFrame::OnTimerChange, "Timer Control", 500,
                        50, 1000, 200);

 // Give it a status line
  CreateStatusLine(2);

  // Make a menubar
  wxMenu *file_menu = new wxMenu;
  file_menu->Append(START_QUIT, "&Quit",                "Quit program");

  wxMenu *timer_menu = new wxMenu;
  timer_menu->Append(START_TIMER_ON, "Timer &on",       "Turn timer on");
  timer_menu->Append(START_TIMER_OFF, "Timer o&ff",     "Turn timer off");


  menu_bar = new wxMenuBar;

  menu_bar->Append(file_menu, "&File");
  menu_bar->Append(timer_menu, "&Timer");


  // Associate the menu bar with the frame
  SetMenuBar(menu_bar);

  menu_bar->Enable(START_TIMER_ON, TRUE);
  menu_bar->Enable(START_TIMER_OFF, FALSE);


 // Create the timer
  timer = new MyTimer;
  timer_on = FALSE;

}

// Intercept menu commands
void StartFrame::OnMenuCommand(int id)
{

  switch (id)
  {

    case START_QUIT:
    {
      //OnClose();
      delete this;
      break;
    }

    case START_TIMER_ON:
    {
      timer->Stop();
      int interval = slider->GetValue();
      timer->Start(interval);
      timer_on = TRUE;
      menu_bar->Enable(START_TIMER_ON, FALSE);
      menu_bar->Enable(START_TIMER_OFF, TRUE);
      break;
    }
    case START_TIMER_OFF:
    {
      timer->Stop();
      menu_bar->Enable(START_TIMER_ON, TRUE);
      menu_bar->Enable(START_TIMER_OFF, FALSE);
      timer_on = FALSE;
      break;
    }
    default:
    {
    }
  }
}

Bool StartFrame::OnClose(void)
{

  //Show(FALSE);
  return TRUE;
}

void StartFrame::OnTimerChange(wxSlider &slider, wxCommandEvent& event) {
     StartFrame* startFrame = (StartFrame*)(slider.GetGrandParent());
     if (startFrame->timer_on) {
         startFrame->timer->Stop();
         int interval = slider.GetValue();
         startFrame->timer->Start(interval);
       }
}






