#ifndef _LOCATION_H
#define _LOCATION_H

/* 
CLASS
   Location

   This class defines the concepts of a Location in a coordinate system
   where the (0,0) position is in the upper left-hand corner. The x-axis
   extends in a positive direction to the right and the y-axis extends in
   a positive direction towards the bottom of the screen.
*/


class Location {			 // Version 1
private:  

     int  currentX, currentY;

public:

     //////////
     // Construct a Location object with the specified x and y coordinates.
     // <UL>
     // <LI><B>x </B>: the x coordinate of the location.
     // <LI><B>y </B>: the y coordinate of the location.
     // </UL>
	Location(int x, int y);	        // specific location

     //////////
     // Construct a Location object at a default location.
        Location();			// default location

     //////////
     // Return the current x coordinate of the Location object.
     int Xcoord();       		// return x-axis coordinate

     //////////
     // Return the current y coordinate of the Location object.
     int Ycoord();        		// return y-axis coordinate
};

#endif




