#ifndef _SHAPE_H
#define _SHAPE_H

/* 
CLASS
   Shape

   This class captures the concepts of the shape of a rectangular
   graphical user interface item (e.g, a window object). Shape
   objects are used to describe the dimensions of the visible
   window of a Frame, and an area within a Frame's visible window.
*/


class Shape {			// Version 1
private:  
   int currentWidth, currentHeight;
public:   

     //////////
     // Construct a Shape object with the specified width and height.
     // <UL>
     // <LI><B>width </B>: the width  of the shape.
     // <LI><B>height </B>: the height of the shape.
     // </UL>
	Shape(int width, int height);	// specific shape

     //////////
     // Construct a Shape object with default height and width.
	Shape();         		// default shape

     //////////
     // Return the current height  of the Shape object.
     int Height();              	// return height

     //////////
     // Return the current width of the Shape object.
     int Width();               	// return width

};

#endif





