#ifndef _BLINKMSG_H
#define _BLINKMSG_H

#include "Location.h"
#include "Frame.h"

class BlinkingMessage {
 private:
   char     *text;               // text being displayed
   Location  location;           // at this location
   Frame    *frame;              // in this window
   int       visible;

   void Clear();
   void Draw();

 public:

   BlinkingMessage(char *textString, Location whereAt);
   BlinkingMessage(Location whereAt);

   void DisplayIn(Frame& whichFrame);
   void MoveTo(Location newLocation);
   void SetText(char *newText);
   char *GetText();
   void Blink();
   void Redraw();

   ~BlinkingMessage();
};

#endif



