#ifndef _CLOCK_H
#define _CLOCK_H

#include "wx.h"
#include "wx_timer.h"
#include "Counter.h"

/* This class captures the concept of a simple timer. The granularity of
   the timer is in milliseconds. The granularity is specified when a
   Timer Object is "Start"ed. For example, for a timer object t, t.Start(100) 
   will Start the timer and set the granularity to 100 milliseconds (a tenth
   of a second).
*/


class ClockMechanism : public wxTimer {
private:
  Counter* count;
public:
  ClockMechanism();
  void ConnectTo(Counter& c);
  void Notify(void);
  
};

class Clock {
private:
  ClockMechanism timer;
  int interval;
public:
  Clock (int m);
  void ConnectTo(Counter& c);
  void Start();
  void Stop();
  
};

#endif

