#ifndef _COUNTER_H
#define _COUNTER_H

/*  This class captures the concept of a simple integer counter that
    counts upwards from a given, by default zero, initial value. A
    Counter object can be connected to a Message in which the counter
    will display its current value.
*/

#include "Message.h"


class Counter {
private:
  int      initial, final, step;
  int      bounded;
  int      value;
  Message* message;

public:
  Counter(int start, int end);
  Counter();
  void ConnectTo(Message& msg);
  void Next();
  void Reset();
 ~Counter();

};


#endif


