#ifndef _MESSAGE_H
#define _MESSAGE_H

#include "Location.h"
#include "Frame.h"

class Message {
 private:
   char     *text;               // text being displayed
   Location  location;           // at this location
   Frame    *frame;              // in this window

 public:
   Message(char *textString, Location whereAt);
   Message(Location whereAt);
   void DisplayIn(Frame& whichFrame);
   void MoveTo(Location newLocation);
   void SetText(char *newText);
   char *GetText();
   void Draw();
   void Clear();
   ~Message();
};

#endif



