// this is the file Program.cc

#include "Program.h"
#include "Frame.h"
#include "Clock.h"
#include "Counter.h"
#include "Location.h"
#include "Shape.h"
#include "Message.h"


   // an association that forms a simple one second timer
   // with a text display 

Frame   simpleTimer("Simple Timer", Location(100,100), Shape(300,300));
Clock   timer(1000);	// 1000 millisecond interval 
Counter elapsedTime;	// increments on each 'tick' of timer
Message display("0", Location(20,50));
Message warning1("Left-click to stop timer", Location(10,100));
Message warning2("before exiting.", Location(10,120));


// Note: the OnMouseEvent code has been added to give a way to
// stop the timer before exiting the program. If you exit the
// program while the timer is running, the program may end
// abnormally if the timer goes off while the program is in
// the process of terminating.

void OnStart(void) {
  display.DisplayIn(simpleTimer);
  elapsedTime.ConnectTo(display);
  timer.ConnectTo(elapsedTime);
  warning1.DisplayIn(simpleTimer);
  warning2.DisplayIn(simpleTimer);
  timer.Start();
}

void OnMouseEvent(char *frameName, int x, int y, int buttonState){
  if(buttonState & leftButtonDown)
    timer.Stop();
}

void OnTimerEvent(void){}

void OnPaint(void){
   display.Draw();
   warning1.Draw();
   warning2.Draw();
}
