#include "FrameMgr.h"


FrameManager::FrameManager(int numFrames) {
	maxFrames = numFrames;
	frames = new FrameArray[maxFrames];
	last = 0;
}

void FrameManager::Add(Frame& frame) {
	if (last < maxFrames)
	{ frames[last] = &frame;
	  last = last + 1;
	}
}

void FrameManager::Add(Frame* frame) {
	if (last < maxFrames)
	{ frames[last] = frame;
	  last = last + 1;
	}
}

Frame* FrameManager::FindByName(char* frameName) {
	int found = 0;
	while(found < last && !frames[found]->IsNamed(frameName))
		found = found + 1;
	if (found < last) return frames[found];
		else return (Frame*)0;
}

void FrameManager::Remove(Frame& frame) {
	Remove(&frame);
}

void FrameManager::Remove(Frame* frame) {
	int entry = 0;
	while (entry < last && !(frames[entry] == frame))
		entry = entry + 1;
	while (entry < last) {
			frames[entry] = frames[entry+1];
			entry = entry + 1;
	}
}

FrameManager::~FrameManager(){
	delete frames;
}