#include "Program.h"
#include "Frame.h"
#include "Canvas.h"
#include "Message.h"
#include "Location.h"
#include "Shape.h"
#include "Clock.h"

/*

   This sample program illustrates the use of Clock objects to
   generate timing events. Note that a Clock object is given a
   name when it is constructed. When a Clock object generates a
   timing event, it calls OnTimerEvent passing its name as an
   argument. The timer that is controlled from the StartWindow
   is still available. It will also call OnTimerEvent passing as
   its name "StartWindow".

*/


Frame   window   ("Message Test", Location(100,100), Shape(200,200));
Canvas  canvas   (window, "Message Area", Location(10,10), Shape(180,180));
Message greeting ("Hello World!", Location(20,20));
Clock   timer    ("timer", 500);
int     onoff;

void OnStart() {
   greeting.DisplayIn(canvas);
   greeting.Draw();
   onoff = 1;
   timer.Start();
};

void OnMouseEvent(char *frameName, int x, int y, int buttonState){}

void OnTimerEvent(char* clockName) 
{
   if( timer.IsNamed(clockName) )
   {   if (onoff) { greeting.Clear(); onoff = 0; }
       else       { greeting.Draw();  onoff = 1; }
   }
}

void OnPaint() {
   if (onoff) greeting.Draw(); 
}          

void OnPush(char* buttonName) {}
