#include "TextBox.h"




TextBox::TextBox(Location p, Shape s, char* label) {
     position = p; shape = s; 
     currentLabel  = copystring(label); 
     currentValue  = (char*)0;
     systemTextBox = (wxText*)0;
}

TextBox::TextBox( Location p, Shape s) {
     position = p; shape = s; 
     currentLabel = (char*)0; 
     currentValue  = (char*)0;
     systemTextBox = (wxText*)0;
}

TextBox::TextBox( char* label) {
     currentLabel  = copystring(label); 
     currentValue  = (char*)0;
     systemTextBox = (wxText*)0;
}

TextBox::TextBox() {
     currentLabel  = (char*)0;
     currentValue  = (char*)0;
     systemTextBox = (wxText*)0;
}
  
TextBox::~TextBox() {
  if (currentLabel) delete currentLabel;
  if (currentValue) delete currentValue;
}

char* TextBox::GetText() { 
     if(systemTextBox) {
         if (currentValue) delete currentValue;
         currentValue =  copystring(systemTextBox->GetValue());
     }
     return copystring(currentValue);
}

void TextBox::SetText(char* val) { 
     currentValue = copystring(val);
     if (systemTextBox) systemTextBox->SetValue(val);
}




