#include "TxtFrame.h"
#include "wx.h"


void TextFrame::CreateIfNeeded() {
 if (!frame) {
      frame = new BasicTextFrame( name, location.Xcoord(), location.Ycoord(),
                                        shape.Width(), shape.Height(), this);
      frame->Show(TRUE);
   }
}

TextFrame::TextFrame(char *nm, Location loc, Shape sh ) {
     name     = copystring(nm); 
     location = loc;
     shape    = sh;
     frame    = (BasicTextFrame*)0; 
}

TextFrame::TextFrame(char *nm, Location loc) {
     name     = copystring(nm); 
     location = loc;
     shape    = Shape(100,100);
     frame    = (BasicTextFrame*)0; 
}

TextFrame::TextFrame(char *nm, Shape sh) {
     name     = copystring(nm); 
     location = Location(100,100);
     shape    = sh;
     frame    = (BasicTextFrame*)0; 
}
  
  
TextFrame::TextFrame(char *nm) {
     name   = copystring(nm); 
     location = Location(100,100);
     shape    = Shape(100,100);
     frame  = (BasicTextFrame*)0; 
}

TextFrame::TextFrame(){
     name     = copystring("TextFrame");
     location = Location(100,100);
     shape    = Shape(100,100);
     frame    = (BasicTextFrame*)0; 
}
        
TextFrame::~TextFrame() {
     if (frame) delete frame;
}

void TextFrame::MoveTo( Location loc ) {
       CreateIfNeeded();
       location = loc;
       frame->SetSize( location.Xcoord(), location.Ycoord(), 
                       shape.Width(), shape.Height());
}

void TextFrame::Resize( Shape sh) {
       CreateIfNeeded();        
       shape = sh;
       frame->SetSize( location.Xcoord(), location.Ycoord(), 
                       shape.Width(), shape.Height());
}

void TextFrame::Resize(float factor) {
       CreateIfNeeded();
       int width = (int)(shape.Width()*factor);
       int height= (int)(shape.Height()*factor);
       shape = Shape(width, height);
       frame->SetSize( location.Xcoord(), location.Ycoord(), 
                       shape.Width(), shape.Height());
}


int TextFrame::IsNamed(char *nm) {
   if (strcmp(name, nm) == 0) return 1;
   return 0;
 }

TextFrame& TextFrame::operator<<(char *s){
  CreateIfNeeded();
  (*(frame->textWindow)) << s;
  return *this;
}
TextFrame& TextFrame::operator<<(int i){
  CreateIfNeeded();
  (*(frame->textWindow)) << i;
  return *this;
}
TextFrame& TextFrame::operator<<(long l){
  CreateIfNeeded();
  (*(frame->textWindow)) << l;
  return *this;
}
TextFrame& TextFrame::operator<<(float f){
  CreateIfNeeded();
  (*(frame->textWindow)) << f;
  return *this;
}
TextFrame& TextFrame::operator<<(double d){
  CreateIfNeeded();
  (*(frame->textWindow)) << d;
  return *this;
}
TextFrame& TextFrame::operator<<(char c){
  CreateIfNeeded();
  (*(frame->textWindow)) << c;
  return *this;
}








