#ifndef _CLOCK_H
#define _CLOCK_H

#include "wx.h"
#include "wx_timer.h"
#include "Counter.h"

/* This class captures the concept of a simple timer. The granularity of
   the timer is in milliseconds. The granularity is specified when a
   Timer Object is "Start"ed. For example, for a timer object t, t.Start(100) 
   will Start the timer and set the granularity to 100 milliseconds (a tenth
   of a second).
*/

class Clock;

class ClockMechanism : public wxTimer {
private:
  char* clockName;
public:
  ClockMechanism(char* name);
  void Notify(void);
};

class Clock {
private:
  ClockMechanism timer;
  int   clockInterval;
  char* clockName;
public:
  Clock (char* name, int interval=1000);
  void SetInterval(int newInterval);
  void Start();
  void Stop();
  int  IsNamed(char* name);
  ~Clock();
};

#endif

