#ifndef _LOCATION_H
#define _LOCATION_H



/* This class defines the concepts of a Location in a coordinate system
   where the (0,0) position is in the upper left-hand corner. The x-axis
   extends in a positive direction to the right and the y-axis extends in
   a positive direction towards the bottom of the screen.
*/


class Location {			 
private:  

     int  currentX, currentY;

public:

	 Location(int x, int y);	// specific location
         Location();			// default location
     int Xcoord() const;       		// return x-axis coordinate
     int Ycoord() const;        	// return y-axis coordinate
     void setX(int newX);               // change x coordinate
     void setY(int newY);               // change y coordinate
     int isSameAs (const Location& other) const;
	                                // two Locations the same?
     int isInList (const Location* const list,
		   const int listLength) const;
	                                // is this Location in array?
};

#endif




