#ifndef _RECTANGLE2_H
#define _RECTANGLE2_H

#include "Location.h"
#include "Shape.h"
#include "Canvas.h"
#include "Color.h"

// This revised version of the Rectangle class contains
// two extensions to the original class:
//  1. the use of private methods
//  2. the use of a static (class) variable

class Rectangle2
{
  private:
	  Location upperLeft;
	  Location upperRight;
	  Location lowerLeft;
	  Location lowerRight;
	  Shape    area;

	  void AdjustCorners();        //private method

	  static Color rectangleColor; // class variable

  public:
	  Rectangle2 (Location corner, Shape shape);
	  void MoveUp    (int deltaY);
	  void MoveDown  (int deltaY);
	  void MoveLeft  (int deltaX);
	  void MoveRight (int deltaX);
	  void Draw(Canvas& canvas);
	  void Clear(Canvas& canvas);
	  void SetColor(Color color);
	  ~Rectangle2();
};

#endif
