
#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Color.h"
#include "Clock.h"


/* This program illustrates the use of colors in drawing
   shapes on a Canvas object. As the triangle moves, the
   lines drawing the triangle turn from Blue to Red.
*/

  
// Declare object here

     Frame window  ("TestWindow", Location(100,100), Shape(500, 300));
     Canvas canvas (window, "DrawAreas",  Location(1, 1),  Shape(100, 100));
     Clock timer("Timer",30);
     Location triangle[3];
	 Color drawColor(25,25,200);


void OnStart()	      // called once when "Start" button pushed
{  canvas.Clear();
   canvas.SetDrawColor(drawColor);
   triangle[0] = Location(100,  50);
   triangle[1] = Location( 25, 150);
   triangle[2] = Location(175, 150);
   canvas.DrawLine(triangle[0], triangle[1]);
   canvas.DrawLine(triangle[1], triangle[2]);
   canvas.DrawLine(triangle[2], triangle[0]);
   timer.Start();
}


void OnPush(char *buttonLabel) 
{  
}

void OnPaint()
{ canvas.Clear();
  canvas.SetDrawColor(drawColor);
  canvas.DrawLine(triangle[0], triangle[1]);
  canvas.DrawLine(triangle[1], triangle[2]);
  canvas.DrawLine(triangle[2], triangle[0]);
} 


void OnTimerEvent(char* clockName) 
{ for(int i=0; i<3; i++)
    triangle[i] = Location(triangle[i].Xcoord()+5,
						   triangle[i].Ycoord());
  canvas.Clear();
  drawColor = Color(drawColor.Red()+3, 25, drawColor.Blue()-3);
  canvas.SetDrawColor(drawColor);
  canvas.DrawLine(triangle[0], triangle[1]);
  canvas.DrawLine(triangle[1], triangle[2]);
  canvas.DrawLine(triangle[2], triangle[0]);
  if (triangle[2].Xcoord() >= 490) timer.Stop(); 
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{
}








