
#include "Base.h"
#include "Frame.h"
#include "Canvas.h"
#include "Color.h"
#include "Clock.h"
#include "Message.h"
#include "MessageList.h"
#include "Program.h"


/* 
   This program illustrates the use of a MessageList. All of
   the Messages added to the MessageList blink together.
  
*/

  
// Declare object here

     Frame window  ("TestWindow", Location(100,100), Shape(500, 300));
     Canvas canvas (window, "DrawAreas",  Location(1, 1),  Shape(100, 100));
     Clock timer("Timer",100);
	 Message *msg1;
	 Message *msg2;
	 Message *msg3;
	 MessageList msgList;
	 int visible;


void OnStart()	      // called once when "Start" button pushed
{  canvas.Clear();
   canvas.SetFillColor(Color(25,0,0));
   msg1 = new Message("Now is the time",    Location(20, 20));
   msg2 = new Message("For all good men",   Location(20, 40));
   msg3 = new Message("To come to the aid", Location(20, 60));
   msg1->DisplayIn(canvas);
   msg2->DisplayIn(canvas);
   msg3->DisplayIn(canvas);
   msgList.AddAtEnd(msg3);
   msgList.AddAtFront(msg2);
   msgList.AddAtFront(msg1);
   visible = 0;
   timer.Start();
}


void OnPush(char *buttonLabel) 
{  
}

void OnPaint()
{ if (visible) { msgList.ClearAll(); visible = 1; }
  else         { msgList.DrawAll();  visible = 0; } 
} 


void OnTimerEvent(char* clockName) 
{ if (visible) { msgList.ClearAll(); visible = 0; }
  else         { msgList.DrawAll();  visible = 1; } 
}

void OnMouseEvent(char *canvasName, int x, int y, int keys)
{ if (keys & leftButtonDown)  
  { timer.Stop();
    msgList.DrawAll();
  }
}








