

#include "wx.h"
#include "FlChoose.h"
#include "Directry.h"
#include "Selector.h"


FileChooser::FileChooser (char* path, char* filter) {
   thePath   = copystring(path); 
   theFilter = copystring(filter);
}

FileChooser::FileChooser(char* path) {
   thePath   = copystring(path); 
   theFilter = "*.*";
}

FileChooser::FileChooser() {
    thePath   = copystring(wxGetWorkingDirectory());
    theFilter = "*.*"; 
}

File FileChooser::AskUser() {
   Directory directory(thePath, theFilter);
   Selector selector(thePath);

   char* nextName = directory.First();
   while (nextName) {
     selector.Add(nextName);
     nextName = directory.Next();
   }
   
   char* fileChosen = selector.AskUser();
   return File(fileChosen);

}

FileChooser::~FileChooser() {}
