#include "Message.h"
#include "wx.h"

Message::Message(char *textString, Location whereAt){
  text = copystring(textString);
  location = whereAt;
  canvas = (Canvas*)0;
}

Message:: Message(Location whereAt){
  text = "";
  location = whereAt;
  canvas = (Canvas*)0;
}

Message::Message(const Message& other) {
   text = copystring(other.text);
   location = other.location;
   canvas = other.canvas;
}

void Message::DisplayIn(Canvas& whichCanvas) {
   canvas = &whichCanvas;
 }

void Message::MoveTo(Location newLocation){
  if (canvas) {
     Clear();
     location = newLocation;
     canvas->DrawText(text, location);
   }
  else location = newLocation;
}

void Message::SetText(char *newText){
  if (canvas) {
     Clear();
     delete text;
     text = copystring(newText);
     Draw();
   }
  else {
     delete text;
     text = copystring(newText);
   }
}

void Message::Draw() {
   if(canvas) 
     canvas->DrawText(text, location);
}

void Message::Clear() {
   if(canvas) {
     Shape msgShape = canvas->TextSize(text);
     canvas->Clear(location, msgShape);
   }
}

char* Message::GetText(){
  return copystring(text);
} 

void Message::operator=(const Message& other) {
  delete text;
  text     = copystring(other.text);
  location = other.location;
  canvas   = other.canvas;
}

Message:: ~Message(){
  delete text;
}
