
#include "Rectangle1.h"


Rectangle1::Rectangle1(Location corner, Shape shape)
{ upperLeft  = corner;
  area = shape;
  upperRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

void Rectangle1::MoveUp(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() - deltaY);
  upperRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

void Rectangle1::MoveDown(int deltaY)
{ upperLeft  = Location(upperLeft.Xcoord(),
						upperLeft.Ycoord() + deltaY);
  upperRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

void Rectangle1::MoveLeft(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() - deltaX,
						upperLeft.Ycoord());
  upperRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

void Rectangle1::MoveRight(int deltaX)
{ upperLeft  = Location(upperLeft.Xcoord() + deltaX,
						upperLeft.Ycoord());
  upperRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord());
  lowerLeft  = Location(upperLeft.Xcoord() ,
	                    upperLeft.Ycoord() + area.Height());
  lowerRight = Location(upperLeft.Xcoord() + area.Width(),
	                    upperLeft.Ycoord() + area.Height());
}

void Rectangle1::Draw(Canvas& canvas)
{ canvas.DrawLine(upperLeft,  upperRight);
  canvas.DrawLine(upperRight, lowerRight);
  canvas.DrawLine(lowerRight, lowerLeft);
  canvas.DrawLine(lowerLeft,  upperLeft);
}

void Rectangle1::Clear(Canvas& canvas)
{ canvas.Clear(Location(upperLeft.Xcoord()-1,
			            upperLeft.Ycoord()-1),
			   Shape(area.Width()+5,
			         area.Height()+5));
}

Rectangle1::~Rectangle1() {}