#include "StopWatch.h"

Location StartButtonLocation = Location(10,10);
Shape    StartButtonShape    = Shape(50,20);

Location StopButtonLocation  = Location(70,10);
Shape    StopButtonShape     = Shape(50,20);

Location ButtonPanelLocation = Location(10,60);
Shape    ButtonPanelShape    = Shape(130,40);

Location CanvasLocation      = Location(10,20);
Shape    CanvasShape         = Shape(130,30);

Location ClockDisplayLocation= Location(60,10); 


StopWatch::StopWatch(Frame& frame, Location where,
					 int interval)
: // subobject constructor list
 
  clock("StopWatchClock", interval),
  buttonPanel( frame,  "ButtonPanel", 
	           Location(where.Xcoord() +
			            ButtonPanelLocation.Xcoord(),
						where.Ycoord() +
						ButtonPanelLocation.Ycoord()),
			   ButtonPanelShape),

  startButton("Start", 
	           StartButtonLocation,
			   StartButtonShape),

  stopButton ("Stop",  
	           StopButtonLocation,
		   	   StopButtonShape),

  canvas     ( frame,  "StopWatchCanvas", 
	           Location(where.Xcoord() +
			            CanvasLocation.Xcoord(),
						where.Ycoord() +
						CanvasLocation.Ycoord()),
			   CanvasShape),

  clockDisplay( "0", 
                ClockDisplayLocation)

{ // constructor body
  buttonPanel.Add(stopButton);
  buttonPanel.Add(startButton);
  canvas.Clear();
  clockCount.ConnectTo(clockDisplay);
  clockDisplay.DisplayIn(canvas);
  clock.Start();
}
	  
     
void StopWatch::ButtonPushed(char* buttonName)
{ if (startButton.IsNamed(buttonName))
     clock.Start();
  else if (stopButton.IsNamed(buttonName))
	 clock.Stop();
}

void StopWatch::Tick()
{ clockCount.Next();
}

int StopWatch::ElapsedTime()
{ return clockCount.Value();
}

StopWatch::~StopWatch() {}